#!/usr/bin/python

import numpy as na
import numpy.oldnumeric.mlab as mlab
import controlMountSocket
import common
import time

class ZaberControl:

    #################  Zaber functions ###############

    def __init__(self, host):
	print "host= " , host

    #move zaber function
    def zaber_move(self,widget,direction,actuator):
        zz = long(100)
 	act = [1, 6, 2, 5, 3, 4, 7, 8]
        act = [{'IN':[1, -10*zz], 'OUT':[1,  10*zz]},
               {'IN':[2,  10*zz], 'OUT':[2, -10*zz]},
               {'IN':[3, -10*zz], 'OUT':[3,  10*zz]},
               {'IN':[4,  10*zz], 'OUT':[4, -10*zz]},
               {'IN':[5, -10*zz], 'OUT':[5,  10*zz]},
               {'IN':[6,  10*zz], 'OUT':[6, -10*zz]},
               ]
        self.zab.move_relative(act[actuator-1][direction][0], 1, act[actuator-1][direction][1])
       # self.zaber_refresh_pos(0)
            
     	

    #functions for saving current position to a file
    def zaber_save_pos(self,widget):		
        self.zaber_save_filew = gtk.FileSelection('Save all positions to file')
        self.zaber_save_filew.connect("destroy",lambda w: self.zaber_save_filew.destroy())
        self.zaber_save_filew.ok_button.connect("clicked",self.zaber_file_save_action)
        self.zaber_save_filew.cancel_button.connect("clicked",lambda w: \
                                                    self.zaber_save_filew.destroy())
        self.zaber_save_filew.show()

    #function to actually do the filesaving
    def zaber_file_save_action(self,widget):
        self.zab.save_position(self.zaber_save_filew.get_filename(),self.m)
        print "save info to %s" % self.zaber_save_filew.get_filename()
        self.zaber_save_filew.destroy()

    #functions for recalling position from a file
    def zaber_recall_pos(self,widget):
        self.zaber_recall_filew = gtk.FileSelection('Recall all positions from file')
        self.zaber_recall_filew.connect("destroy",lambda w: self.zaber_recall_filew.destroy())
        self.zaber_recall_filew.ok_button.connect("clicked",self.zaber_file_recall_action)
        self.zaber_recall_filew.cancel_button.connect("clicked",\
                                                      lambda w: self.zaber_recall_filew.destroy())
        self.zaber_recall_filew.show()
                
    #function that actually recalls the file
    def zaber_file_recall_action(self,widget):
        self.zab.recall_position(self.zaber_recall_filew.get_filename(),self.m)
        print "recalled info from %s" % self.zaber_recall_filew.get_filename()
        self.zaber_recall_filew.destroy()		
			
    def zaber_renumber_mount(self,widget):            
        print 'renumbering mounts '
        self.nzaber = self.zab.renumber()
	print "self.nzaber = ", self.nzaber
				
    def zaber_restart_mounts(self,widget):
        self.zab.restart()
        self.zab.renumber_mount(0)		

    def zaber_home(self,widget,actuator):
        print 'actuator = ', actuator	
        self.zab.home(actuator, 1)
        self.zaber_refresh_pos(0)

    def zaber_read_file(self,actuator, filename):
        file = open(filename)
        text = file.read()
        positions = text.split("\n")
        self.zab.move_absolute(actuator, 1, long(positions[actuator-1]))
        self.zaber_refresh_pos(0)

    def auto_cross_section_toggled(self,widget):
        self.auto_cross_section = self.auto_cross_section_check.get_active()		

    #function for combo box to enter/see exact postion of ealing actuator:
    def zaber_menu_changed(self,combo_box):
	act = [1, 2, 3, 4, 5, 6]
        self.actuator = act[combo_box.get_active()]
				
        #insert function to set text on position box
        self.zaber_refresh_pos(0)

    def zaber_move_to_pos(self,widget):
        self.zab.move_absolute(self.actuator, 1, long(self.zaber_position_entry.get_text()))
        
    def zaber_refresh_pos(self,widget):
        self.zaber_position_entry.set_text(str(self.zab.absolute_position(self.actuator, 1)))

    def main(self):        
        gtk.main()
